class Hour implements Comparable<Hour>{
  class Word{
    String word;
    float frequency;
    
    Word(String s, float f){
      word = s;
      frequency = f;
    }
  };
  
  @Override
  public int compareTo(Hour other){
    return (this.date.getTime() < other.date.getTime() ) ? -1: (this.date.getTime() > other.date.getTime()) ? 1:0 ;
  }
  
  // date
  Date date;
  // total checkouts
  float amount;
  // keyword frequency array
  ArrayList<Word> words;
  
  // weather data
  float temp;
  float windDir;
  float windStr;
    
  Hour(Date d, float a, float t, float dir, float str){
    date = d;
    amount = a;
    
    temp = t;
    windDir = dir;
    windStr = str;
    
    words= new ArrayList<Word>();
  }
  
  void addWord(String w, float f){
    words.add(new Word(w, f));
  }
};