import peasy.*;
import peasy.org.apache.commons.math.geometry.Rotation;
import peasy.org.apache.commons.math.geometry.Vector3D;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;
import controlP5.*;
import processing.sound.*;

// CSV tables for weather and SPL data
Table keywordCSV;
Table weatherCSV;

// GUI Drawings
ControlP5 cp5;

// Camera
PeasyCam cam;
PeasyDragHandler singleDragHandler;

// font to be used throughout
PFont font;

// Main date to Weather hashmap
HashMap<Date,   Weather> weatherMap = new HashMap<Date, Weather>();

// Main word to Keyword hasmap
HashMap<String, Keyword> keywordMap = new HashMap<String, Keyword>();

// Main Hour array
ArrayList<Hour> hoursArray = new ArrayList<Hour>();

// Result of search keywords
List<String> selectedKeywords = new ArrayList();

// Entered text
String textValue = "";

// Colors
color background = color(30);
color foreground = color(225);

// toggles
boolean autorotate = true;
boolean useColors = false;

// boundaries
Date beginDate;
Date endDate;

float globalMinTemp =  999;
float globalMaxTemp = -999;
float globalMinMeanTemp =  999; 
float globalMaxMeanTemp = -999;
float globalMinMeanWindStr =  999; 
float globalMaxMeanWindStr = -999;

float globalMinAmount =  999999;
float globalMaxAmount = -999999;

float globalMaxFrequency = 0;
float globalMaxMeanFrequency = 0;

float globalMaxCount = 0;

// Slider extremes
float sliderMinMeanFrequency = 0;
float sliderMaxMeanFrequency = 0;
float sliderMinMeanWind = 0;
float sliderMaxMeanWind = 0;
float sliderMinMeanTemp = 0;
float sliderMaxMeanTemp = 0;