class Weather{
  float temp;
  float windDir;
  float windStr;
  
  Weather(float t, float dir, float s){
    temp = t;
    windDir = dir;
    windStr = s;
  }
};

// Load Weather Table
void readWeatherTable(){
  for(int i = 0; i < weatherCSV.getRowCount(); i++){
    DateFormat df = new SimpleDateFormat("MM/dd/yyyy h:mm a"); 
    Date date;
    try {
      date = df.parse(weatherCSV.getString(i, "DATE")+" "+weatherCSV.getString(i, "TIME"));
      
      globalMaxTemp = max(safeGetFloat(weatherCSV, i, "TEMPF"), globalMaxTemp);
      globalMinTemp = min(safeGetFloat(weatherCSV, i, "TEMPF"), globalMinTemp);
      
      weatherMap.put(date, new Weather(safeGetFloat(weatherCSV, i, "TEMPF"),
                                       safeGetFloat(weatherCSV, i, "DIR"),
                                       safeGetFloat(weatherCSV, i, "SPD")));
    } catch (Exception e) {
      println("WEATHER:");
      e.printStackTrace();  
    }
  }
}